
var proj1 = 'EPSG:4326';
var proj2 = 'EPSG:3857';
var tooltip;
var tooltipContainer ;
var tooltipContent ;
var osm, osmRecorrido, satelite, view;

function creaLayers(){
    /*osm = new ol.layer.Tile({
        source: new ol.source.OSM(),
        title: 'OSM',
	    visible: true
    });*/
    /*satelite = new ol.layer.Tile({
        source: new ol.source.XYZ({
            url: 'https://1.aerial.maps.cit.api.here.com' +
                '/maptile/2.1/maptile/newest/hybrid.day/{z}/{x}/{y}/256/png' +
                '?app_id=mZGTWUktUIsDtgcDik8t&app_code=5CbS9GS4d1UPw1ldDidkjw',
            attribution: "&copy; 2013 Nokia</span>&nbsp;<a href='http://maps.nokia.com/services/terms' target='_blank' title='Terms of Use' style='color:#333;text-decoration: underline;'>Terms of Use</a></div> <img src='http://ap    i.maps.nokia.com/2.2.4/assets/ovi/mapsapi/by_here.png' border='0'>",
            transitionEffect: "resize",
            numZoomLevels: 20
        }),
        title: 'Satelite',
        visible:true 
    });*/
    vectorLayer = new ol.layer.Vector({
        projection: proj1,
        zIndex:2000,
        title: 'Moviles'
    });
    vsMarcadores = new ol.source.Vector({
        projection: proj1
    });
}

function creaMapa(){
    tooltipContainer = document.getElementById('tooltip');
    tooltipContent = document.getElementById('tooltip-content');
    view = new ol.View({
        center: ol.proj.fromLonLat([ lon, lat]),
        zoom:18 
    });
    map = new ol.Map({
        layers: [ new ol.layer.Tile({
            source: new ol.source.XYZ({
                url: 'https://1.aerial.maps.ls.hereapi.com/maptile/2.1/maptile/newest/hybrid.day/{z}/{x}/{y}/256/png8?apiKey=bk078zAxT7_qc6vTEnl3DsDO-SBLUYnr_g7eZERM0NQ',
                attribution: "&copy; 2013 Nokia</span>&nbsp;<a href='http://maps.nokia.com/services/terms' target='_blank' title='Terms of Use' style='color:#333;text-decoration: underline;'>Terms of Use</a></div> <img src='http://ap    i.maps.nokia.com/2.2.4/assets/ovi/mapsapi/by_here.png' border='0'>",
                transitionEffect: "resize",
                numZoomLevels: 20
            }),
            title: 'Satelite',
            visible:true 
        })],
        target: document.getElementById('map'),
        projection: 'EPSG:4326',
        view: new ol.View({
            center: ol.proj.fromLonLat([ lon, lat]),
            zoom:18 
        }),
        controls: ol.control.defaults({
            zoom: true,
            attribution: true,
            rotate:false
        }),
    });
    map.addLayer(vectorLayer);

    var mousePosition = new ol.control.MousePosition({
            coordinateFormat: ol.coordinate.createStringXY(4),
            projection: 'EPSG:4326',
            target: document.getElementById('myposition'),
            undefinedHTML: '&nbsp;'
    });
    var layerSwitcher = new ol.control.LayerSwitcher();
    map.addControl(layerSwitcher);

    tooltip = new ol.Overlay({
        element: tooltipContainer,
        autoPan: true,
        autoPanAnimation: {
            duration: 250
        }
    });
    map.addOverlay(tooltip);
    map.addControl(mousePosition);

    /*map.on('pointermove', function(evt) {
        var feature = map.forEachFeatureAtPixel(evt.pixel,
            function(feature) {
                return feature;
        });
        if (feature) {
            var props = feature.getProperties();
            var rec = storePosiciones.getById(props.placa);
            var h = creaHtml(rec);
            //var p = Ext.getCmp('pnlEste').update(h);
            var coordinates = feature.getGeometry().getCoordinates();
            popup.innerHtml = h;
            console.log("MOuse Over "+coordinates);
            popup.setPosition(coordinates); 
        }
    });
    */
    /*map.on('pointermove', function(evt) {
        var feature = map.forEachFeatureAtPixel(evt.pixel,
        function(feature) {
            var props = feature.getProperties();
            var coordinates = feature.getGeometry().getCoordinates();
            //tooltipContent.innerHTML = '<p>Fecha:' + props.fecha +'<br>Vel.:'+props.posicion+ '</p>';
            tooltipContent.innerHTML = creaHtml(props);
            tooltip.setPosition(coordinates);
            return feature;
        });
        if (feature) {
            var coordinates = feature.getGeometry().getCoordinates();
        } else {
            tooltip.setPosition()
        }
    });*/

    map.on('click', function(evt) {
	     var feature = map.forEachFeatureAtPixel(evt.pixel,
        function(feature) {
            var props = feature.getProperties();
            var coordinates = feature.getGeometry().getCoordinates();
            //tooltipContent.innerHTML = '<p>Fecha:' + props.fecha +'<br>Vel.:'+props.posicion+ '</p>';
            tooltipContent.innerHTML = creaHtml(props);
            tooltip.setPosition(coordinates);
            return feature;
        });
        if (feature) {
            var coordinates = feature.getGeometry().getCoordinates();
        } else {
            tooltip.setPosition()
        }
    });

}
function displayTooltip(evt) {
    var pixel = evt.pixel;
    var feature = map.forEachFeatureAtPixel(pixel, function(feature) {
        return feature;
    });
    tooltip.style.display = feature ? '' : 'none';
    if (feature) {
        overlay.setPosition(evt.coordinate);
        tooltip.innerHTML = feature.get('placa');
    }
};
function cargaMarkers(){
    vsMarcadores.clear();
    var r;
	storePosiciones.each(function(rec){
        r = rec;
		var col;
		var lon = Number(rec.data.longitud);
		var lat = Number(rec.data.latitud);
		var ll = ol.proj.fromLonLat([lon, lat]);
		punto = new ol.geom.Point(ll);
		var iconFeature = new ol.Feature({
			id: rec.data.placa,
			geometry: punto,
			placa: rec.data.placa,
            fecha: rec.data.fecha_gps,
            posicion: rec.data.posicion,
            velocidad:rec.data.velocidad,
            direccion:rec.data.direccion,
			latitud:rec.data.latitud,
			longitud:rec.data.longitud
        });
        var imagen = getIcono(rec);
		var iconStyle = new ol.style.Style({
			image: new ol.style.Icon(({
				anchor: [-5, 5],
				anchorXUnits: 'pixels',
				anchorYUnits: 'pixels',
				scale: 0.2,
				src: imagen
            })),
			/*text: new ol.style.Text({
                text: rec.data.placa,
                anchor: [-15, 15],
				font: fuente,
                stroke: new ol.style.Stroke({
                    color: col
                }),
				//fill: new ol.style.Fill({ color: '#000' }),
				backgroundFill: new ol.style.Fill({ color: '#ffffff' }),
				backgroundStroke: new ol.style.Stroke({ color: '#0B0B61', width:1 }),
				padding: [1,1,1,1]
		    })*/
		});

		iconFeature.setStyle(iconStyle);
	
        vsMarcadores.addFeature(iconFeature);
        r = rec;
        
    });
    
    var lonLat = ol.proj.fromLonLat([Number(r.data.longitud), Number(r.data.latitud)]);
    map.getView().setCenter(lonLat);
    console.log("Inicio "+lonLat);
	vectorLayer.setSource(vsMarcadores);
	
}
function creaHtml(props){

	var cadena = //'<table border="1" style="border-collapse:collapse>'+
		//'<tr><td align="center">'+
		'<table><caption style="text-align:center">'+props.placa+'</caption><tr><td valign="top"><table class="blueTable">'+
		'<tr><td style="padding:3px 7px 2px 7px;"><b>Fecha:&nbsp</b></td><td style="padding:3px 7px 2px 7px;">' + props.fecha +
		'</td></tr><tr><td style="padding:3px 7px 2px 7px;"><b>Pos.:&nbsp</b></td><td style="padding:3px 7px 2px 7px;"><a href="https://www.google.com/maps/@?api=1&map_action=pano&viewpoint='+props.latitud+','+props.longitud+'&heading=11.394244261141466" target="blank">' +props.posicion +'</a>'+
		'</td></tr><tr><td style="padding:3px 7px 2px 7px;"><b>Dir.:&nbsp</b></td><td style="padding:3px 7px 2px 7px;">' +props.direccion +
		'</td></tr><tr><td style="padding:3px 7px 2px 7px;"><b>Vel.&nbsp</b></td><td style="padding:3px 7px 2px 7px;">' +props.velocidad +
		'</td></tr></table></td></tr></table>';
	return cadena;
}
